open Sharing

let display_command = "gedit .tmpgraph.txt > /dev/null 2> /dev/null"
let dot_command = "cat - > .tmpgraph.txt"
let dot_command = "(ssh asie.ens dot -Tpng) > .tmpgraph.png"
let display_command = "eog .tmpgraph.png > /dev/null 2> /dev/null"

let cpt = ref 0

let graph_of_repr file variables names r =
  let defined = ref names in 
  let rec aux r = try
    List.assq r !defined
  with Not_found -> match !r with 
      | Link r -> aux r
      | Repr Var -> 
          (try
            List.assq r variables
          with _ -> failwith "graph_of_repr")
      | Repr (Op (f, t)) -> 
          let name = Printf.sprintf "fun%d" !cpt in 
          incr cpt; 
          defined := (r, name)::!defined;
          let sons = List.map aux t in 
          Printf.fprintf file "   %s [label = \"%s\"];\n" name f;
          List.iter 
            (fun son -> Printf.fprintf file "   %s -> %s;\n" name son)
            sons;
            defined := (r,name)::!defined; name
  in aux r, !defined

let display_solution defined =
  flush stdout;
  let input = Unix.open_process_out dot_command in  
  let defined_node = ref [] in 
  let variables = List.map (fun (x,r) -> (r,x)) defined in 
  Printf.fprintf input "digraph G {\n";
  List.iter (fun (x, r) -> 
    Printf.fprintf input "%s [shape = \"box\"];\n" x;
    let first = 
      try
        List.assq r !defined_node 
      with Not_found -> 
      let (first, nxt_defined_node) = 
        graph_of_repr input variables !defined_node r 
      in 
      defined_node := nxt_defined_node; first
    in 
      Printf.fprintf input "%s -> %s;\n" x first) defined;
  Printf.fprintf input "}\n"; 
  ignore (Unix.close_process_out input); 
  ignore (Unix.system display_command) 
